searchNodes=[{"ref":"Membrane.Element.Hackney.Sink.html","title":"Membrane.Element.Hackney.Sink","type":"module","doc":"An element uploading data over HTTP(S) based on Hackney Element options Passed via struct Membrane.Element.Hackney.Sink.t/0 location Required The URL of a request method Default value: :post HTTP method that will be used when making a request headers Default value: [] List of additional request headers in format accepted by :hackney.request/5 hackney_opts Default value: [] Additional options for Hackney in format accepted by :hackney.request/5 Pads :input Availability:always Bin?false Caps:any Demand&nbsp;unit:bytes Direction:input Mode:pull Name:input"},{"ref":"Membrane.Element.Hackney.Sink.html#membrane_pads/0","title":"Membrane.Element.Hackney.Sink.membrane_pads/0","type":"function","doc":"Returns pads descriptions for Membrane.Element.Hackney.Sink"},{"ref":"Membrane.Element.Hackney.Sink.html#options/0","title":"Membrane.Element.Hackney.Sink.options/0","type":"function","doc":"Returns description of options available for this module"},{"ref":"Membrane.Element.Hackney.Sink.html#t:t/0","title":"Membrane.Element.Hackney.Sink.t/0","type":"type","doc":"Struct containing options for Membrane.Element.Hackney.Sink"},{"ref":"Membrane.Element.Hackney.Sink.Response.html","title":"Membrane.Element.Hackney.Sink.Response","type":"module","doc":"Struct containing HTTP response sent to pipeline via notification after the upload is finished."},{"ref":"Membrane.Element.Hackney.Sink.Response.html#t:t/0","title":"Membrane.Element.Hackney.Sink.Response.t/0","type":"type","doc":""},{"ref":"Membrane.Element.Hackney.Source.html","title":"Membrane.Element.Hackney.Source","type":"module","doc":"This module provides a source element allowing you to receive data as a client using HTTP. It is based upon Hackney library that is responsible for making HTTP requests. See the t/0 for the available configuration options. Element options Passed via struct Membrane.Element.Hackney.Source.t/0 location Required The URL to fetch by the element method Default value: :get HTTP method that will be used when making a request body Default value: &quot;&quot; The request body headers Default value: [] List of additional request headers in format accepted by :hackney.request/5 hackney_opts Default value: [] Additional options for Hackney in format accepted by :hackney.request/5 max_retries Default value: 0 Maximum number of retries before returning an error. Can be set to :infinity. retry_delay Default value: 1 |&gt; Membrane.Time.seconds() Delay between reconnection attempts in case of connection error. is_live Default value: false Assume the source is live. If true, when resuming after error, the element will not use Range header to skip to the current position in bytes. Pads :output Availability:always Bin?false Caps:any Direction:output Mode:pull Name:output"},{"ref":"Membrane.Element.Hackney.Source.html#membrane_pads/0","title":"Membrane.Element.Hackney.Source.membrane_pads/0","type":"function","doc":"Returns pads descriptions for Membrane.Element.Hackney.Source"},{"ref":"Membrane.Element.Hackney.Source.html#options/0","title":"Membrane.Element.Hackney.Source.options/0","type":"function","doc":"Returns description of options available for this module"},{"ref":"Membrane.Element.Hackney.Source.html#t:t/0","title":"Membrane.Element.Hackney.Source.t/0","type":"type","doc":"Struct containing options for Membrane.Element.Hackney.Source"},{"ref":"readme.html","title":"Membrane Multimedia Framework: Hackney Element","type":"extras","doc":"Membrane Multimedia Framework: Hackney Element"},{"ref":"readme.html#this-package-has-been-moved","title":"Membrane Multimedia Framework: Hackney Element - THIS PACKAGE HAS BEEN MOVED","type":"extras","doc":"Use membrane_hackney_plugin This package provides elements that can be used to read files over HTTP using Hackney library. It is part of Membrane Multimedia Framework."},{"ref":"readme.html#installation","title":"Membrane Multimedia Framework: Hackney Element - Installation","type":"extras","doc":"Add the following line to your deps in mix.exs. Run mix deps.get. {:membrane_element_hackney, &quot;~&gt; 0.3&quot;}"},{"ref":"readme.html#sample-usage","title":"Membrane Multimedia Framework: Hackney Element - Sample usage","type":"extras","doc":"Membrane.Element.Hackney.Source This pipeline should get you a kitten from imgur and save as kitty.jpg. To run it you need :membrane_element_file in your project&#39;s dependencies. defmodule DownloadPipeline do use Membrane.Pipeline alias Pipeline.Spec alias Membrane.Element.File alias Membrane.Element.Hackney @impl true def handle_init(_) do children = [ hackney_src: %Hackney.Source{location: &quot;http://i.imgur.com/z4d4kWk.jpg&quot;}, file_sink: %File.Sink{location: &quot;kitty.jpg&quot;}, ] links = %{ {:hackney_src, :source} =&gt; {:file_sink, :sink} } {{:ok, %Spec{children: children, links: links}}, %{}} end end {:ok, pid} = DownloadPipeline.start(nil) DownloadPipeline.play(pid) Membrane.Element.Hackney.Sink The following pipeline is an example of file upload - it requires Goth library with properly configurated credentials for Google Cloud and :membrane_element_file defmodule UploadPipeline do use Membrane.Pipeline alias Membrane.Pipeline.Spec alias Membrane.Element.{File, Hackney} @impl true def handle_init([bucket, name]) do children = [ src: %File.Source{location: &quot;sample.flac&quot;}, sink: %Hackney.Sink{ method: :post, location: build_uri(bucket, name), headers: [auth_header(), {&quot;content-type&quot;, &quot;audio/flac&quot;}] } ] links = %{ {:src, :output} =&gt; {:sink, :input} } {{:ok, %Spec{children: children, links: links}}, %{}} end @impl true def handle_notification(%Hackney.Sink.Response{} = response, element_name, state) do IO.inspect({element_name, response}) {:ok, state} end def handle_notification(_notification, _element_name, state) do {:ok, state} end defp auth_header do {:ok, token} = Goth.Token.for_scope(&quot;https://www.googleapis.com/auth/devstorage.read_write&quot;) {&quot;Authorization&quot;, &quot;\#{token.type} \#{token.token}&quot;} end defp build_uri(bucket, name) do &quot;https://www.googleapis.com/upload/storage/v1/b/\#{bucket}/o?&quot; &lt;&gt; URI.encode_query(uploadType: &quot;media&quot;, name: name) end end {:ok, pid} = UploadPipeline.start([&quot;some_bucket&quot;, &quot;uploaded_file_name.flac&quot;]) UploadPipeline.play(pid)"},{"ref":"readme.html#sponsors","title":"Membrane Multimedia Framework: Hackney Element - Sponsors","type":"extras","doc":"The development of this element was sponsored by Abridge AI, Inc."},{"ref":"readme.html#copyright-and-license","title":"Membrane Multimedia Framework: Hackney Element - Copyright and License","type":"extras","doc":"Copyright 2018, Software Mansion"}]